 /* 
  * UAE - The Un*x Amiga Emulator
  * 
  * SDL Joystick code
  * 
  * Copyright 1997 Bernd Schmidt
  * Copyright 1998 Krister Walfridsson
  */

#include "sysconfig.h"
#include "sysdeps.h"

#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"
#include "inputdevice.h"
#include "SDL.h"

int nr_joysticks;

static SDL_Joystick *joys[MAX_INPUT_DEVICES];

static void read_joy(int nr)
{
    int num, i, axes, axis, jnr;
    SDL_Joystick *joy;

    if (JSEM_ISJOY0 (0, &currprefs) || JSEM_ISJOY0 (1, &currprefs))
	jnr = 0;
    else if (JSEM_ISJOY1 (0, &currprefs) || JSEM_ISJOY1 (1, &currprefs))
	jnr = 1;
    else
	return;

    joy = joys[jnr];
    axes = SDL_JoystickNumAxes (joy);
    for (i = 0; i < axes; i++) {
	axis = SDL_JoystickGetAxis (joy, i);
	setjoystickstate (nr, i, axis, 32767);
    }

    num = SDL_JoystickNumButtons (joy);
    for (i = 0; i < num; i++) {
	int bs = SDL_JoystickGetButton (joy, i) ? 1 : 0;
        setjoybuttonstate (nr, i, bs);
    }
}

void read_joysticks (void)
{
    int i;
    SDL_JoystickUpdate ();
    for (i = 0; i < nr_joysticks; i++)
	read_joy (i);
}

void init_joysticks (void)
{
    int i;
    nr_joysticks = SDL_NumJoysticks ();
    if (nr_joysticks > MAX_INPUT_DEVICES)
	nr_joysticks = MAX_INPUT_DEVICES;
    for (i = 0; i < nr_joysticks; i++)
	joys[i] = SDL_JoystickOpen (i);
}

void close_joysticks (void)
{
    int i;
    for (i = 0; i < nr_joysticks; i++)
	SDL_JoystickClose (joys[i]);
    nr_joysticks = 0;
}
